import { IMap } from '../extensions';
interface IFrom {
    env: {
        mode: string;
        <V = string>(name: string): V;
        <V = string>(name: string, format: (value: V) => V): V;
        <V = string>(name: string, defaultValue: V): V;
        <V = string>(name: string, format: (value: V) => V, defaultValue: V): V;
    };
    packageJson: {
        title: string;
        version: string;
        <V = string>(name: string): V;
        <V = string>(name: string, format: (value: V) => V): V;
        <V = string>(name: string, defaultValue: V): V;
        <V = string>(name: string, format: (value: V) => V, defaultValue: V): V;
    };
}
interface IConfig {
    maxSearchDepthForJSONFiles?: number;
}
export declare function createSettings<T extends IMap>(delegate: (from: IFrom) => T): T;
export declare function createSettings<T extends IMap>(config: IConfig, delegate: (from: IFrom) => T): T;
export {};
